> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tessera.edstratumlabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Patch apiv1courses gradebookcells



## OpenAPI

````yaml /api/openapi.json patch /api/v1/courses/{courseId}/gradebook/cells
openapi: 3.1.0
info:
  title: Tessera API
  version: '1'
servers:
  - url: https://tessera.edstratumlabs.ai
    description: Production
security: []
paths:
  /api/v1/courses/{courseId}/gradebook/cells:
    patch:
      tags:
        - assignments
      operationId: updateGradeCells
      parameters:
        - name: courseId
          in: path
          required: true
          schema:
            type: string
            minLength: 1
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                batchId:
                  type: string
                  minLength: 1
                partial:
                  type: boolean
                changes:
                  minItems: 1
                  maxItems: 200
                  type: array
                  items:
                    type: object
                    properties:
                      assignmentId:
                        type: string
                        minLength: 1
                      studentId:
                        type: string
                        minLength: 1
                      op:
                        type: string
                        enum:
                          - score
                          - clear
                          - excuse
                          - unexcuse
                          - mark-missing
                          - clear-missing
                          - override
                          - clear-override
                          - extend
                          - waive-late
                      value:
                        anyOf:
                          - type: number
                            minimum: 0
                          - type: string
                            minLength: 1
                          - type: 'null'
                      reason:
                        type: string
                      studentNote:
                        type: string
                      expectedVersion:
                        type: integer
                        minimum: 0
                        maximum: 9007199254740991
                    required:
                      - assignmentId
                      - studentId
                      - op
                      - expectedVersion
              required:
                - batchId
                - changes
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  cells:
                    type: array
                    items:
                      anyOf:
                        - type: object
                          properties:
                            ok:
                              type: boolean
                              const: true
                            version:
                              type: integer
                              minimum: -9007199254740991
                              maximum: 9007199254740991
                            display:
                              type: object
                              properties:
                                state:
                                  type: string
                                  enum:
                                    - graded
                                    - late
                                    - missing
                                    - excused
                                    - dropped
                                    - override
                                    - held
                                    - to-grade
                                    - not-submitted
                                    - not-due
                                    - extra-credit
                                    - what-if
                                adjusted:
                                  anyOf:
                                    - type: number
                                      minimum: 0
                                    - type: 'null'
                                raw:
                                  anyOf:
                                    - type: number
                                      minimum: 0
                                    - type: 'null'
                                label:
                                  type: string
                              required:
                                - state
                                - adjusted
                                - label
                              additionalProperties: false
                          required:
                            - ok
                            - version
                            - display
                          additionalProperties: false
                        - type: object
                          properties:
                            conflict:
                              type: boolean
                              const: true
                            current:
                              type: object
                              properties:
                                value: {}
                                by:
                                  anyOf:
                                    - type: string
                                      minLength: 1
                                    - type: 'null'
                                at:
                                  anyOf:
                                    - type: string
                                      minLength: 1
                                    - type: 'null'
                              required:
                                - value
                                - by
                                - at
                              additionalProperties: false
                          required:
                            - conflict
                            - current
                          additionalProperties: false
                required:
                  - cells
                additionalProperties: false
        '400':
          description: API error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorBody'
        '401':
          description: API error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorBody'
        '403':
          description: API error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorBody'
        '404':
          description: API error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorBody'
        '409':
          description: API error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorBody'
        '429':
          description: API error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorBody'
      security:
        - bearerAuth: []
components:
  schemas:
    ApiErrorBody:
      type: object
      required:
        - error
      properties:
        error:
          type: object
          required:
            - code
            - message
          properties:
            code:
              type: string
              enum:
                - unauthenticated
                - forbidden
                - not-found
                - invalid
                - conflict
                - not-ready
                - ai-disabled
                - ai-failed
                - rate-limited
                - too-large
                - unsupported
            message:
              type: string
            details: {}
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: Scoped tsk_… API token or Access JWT

````